Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/src/create_kpp_module.C
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/src/create_kpp_module.C	(revision 3297)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/src/create_kpp_module.C	(revision 3298)
@@ -17,7 +17,24 @@
 //-----------------
 //$Id: create_kpp_module.C 2470 2017-09-14 13:56:42Z forkel $
+// forkel 25.09.2018:  added  automatic line with meechanism name (read mech_list)
+// forkel 20.09.2018:  added  vl_glo = size(tempi,1)
+// ketelsen 18.09.2018: Removed creation of fill_ Subroutine and creation of calls thereof
+//
+// forkel 12.09.2018: Fix in order not to loose the values of qvap and fakt
+//
+// forkel 03.09.2018: Bug fix: moved kppi.add_line("    CALL initialize after fakt = fakti(is)
+// forkel June 2018: added qvap and fakt, re-established original uppercase/lowercase 
+//                    Deleted definition of qvap,fakt in create_kpp_integrate again
+//
+// ketelsen July 2018: Changes for vector mode (edit_WAXPY, edit_FunTemplate, edit_JacTemplate, 
+//                            some cleanup of comments, various changes in create_kpp_integrate)
+//
+// forkel June 2018: Added qvap and fakt, re-established original uppercase/lowercase 
+//
+//
+/ 2017-09-14 13:56:42Z forkel $
 // Removed preprocessor directive __chem again 
 //
-/ 2017-09-14 13:56:42Z forkel $
+// 2017-09-14 13:56:42Z forkel $
 //
 // 
@@ -25,5 +42,5 @@
 //change of some output to lowercase with uppercase Fortran
 //
-// Nov 2016: Intial version (Klaus Ketelsen)
+// Nov 2016: Intial version of KP4 adapted to PALM (Klaus Ketelsen)
 //
 
@@ -49,15 +66,13 @@
    cout << "Create " << module_name << " from kpp Fortran sources" <<endl;
    cout << "Vector mode " << kpp_switches.is_vector() <<endl;
+   cout << "De_indexing " << kpp_switches.de_indexing() <<endl;
 
    create_fortran_files_and_read();
-   cout << "## after create_fortran_files_and_read " <<endl;
 
 // Generate first module lines 
 
      string first_line="MODULE " + module_name;
-     mz_kpp.add_line(first_line);
-     mz_kpp.add_line("!");
-//   mz_kpp.add_line("#if defined( __chem )");
-//   mz_kpp.add_line(" ");
+   mz_kpp.add_line(first_line);
+   mz_kpp.add_line(" ");
 
 //    string e5_line = first_line +"_e5";
@@ -93,5 +108,4 @@
      it->edit_fortran ();
    }
-   cout << "## after edit FORTRAN files            " <<endl;
 
 // Generate a list of single subroutines from kpp-files
@@ -109,7 +123,7 @@
    }
 
-
-   if(kpp_switches.is_vector()) {
-
+   if(kpp_switches.is_vector()) {
+
+   cout << "##### Hier kpp_switches.is_vector          " <<endl;
 //   Change header section
      for(it=kpp_includes.begin();it!=kpp_includes.end();it++) {
@@ -138,6 +152,15 @@
          it->edit_Fun();
        }
-     }
-   cout << "## after Edit individual subroutines    " <<endl;
+       if(it->get_name() == "WAXPY" ) {
+         it->edit_WAXPY();
+       }
+       if(it->get_name() == "FunTemplate" ) {
+         it->edit_FunTemplate();
+       }
+       if(it->get_name() == "JacTemplate" ) {
+         it->edit_JacTemplate();
+       }
+     }
+// cout << "## after Edit individual subroutines    " <<endl;
 
    }
@@ -146,7 +169,12 @@
 
    for(it=kpp_subroutines.begin();it!=kpp_subroutines.end();it++) {
-     if(it->get_name() == "update_rconst") {
+     if(it->get_name() == "Update_RCONST") {
        it->edit_Update_RCONST(Vvar_list);
      }
+
+     if(it->get_name() == "Initialize") {
+       it->edit_Initialize(Vvar_list);
+     }
+
    }
 
@@ -184,32 +212,15 @@
      }
 
-     buf = prefix + "INTERFACE            " + it->get_name() ;
+     buf = prefix + "interface            " + it->get_name() ;
      mz_kpp.add_line(buf);
-     buf = prefix + "  MODULE PROCEDURE   " + it->get_name();
+     buf = prefix + "  module procedure   " + it->get_name();
      mz_kpp.add_line(buf);
-     buf = prefix + "END INTERFACE        " + it->get_name();
+     buf = prefix + "end interface        " + it->get_name();
      mz_kpp.add_line(buf);
      mz_kpp.add_line(" ");
    }
-   for(iv=Vvar_list.begin();iv!=Vvar_list.end();iv++) {
-     string          buf;
-
-     string sub_name = "fill_" + iv->name;
-     buf = "  INTERFACE            " + sub_name;
-     mz_kpp.add_line(buf);
-     buf = "    MODULE PROCEDURE   " + sub_name;
-     mz_kpp.add_line(buf);
-     buf = "  END INTERFACE        " + sub_name;
-     mz_kpp.add_line(buf);
-     buf = "  PUBLIC               " + sub_name;
-     mz_kpp.add_line(buf);
-     mz_kpp.add_line(" ");
-   }
 
    mz_kpp.add_line(" ");
 
-   for(iv=Vvar_list.begin();iv!=Vvar_list.end();iv++) {
-     create_fill_routine(kpp_subroutines, *iv);
-   }
 
 // Copy FORTRAN subroutines to mz_kpp
@@ -224,19 +235,7 @@
 // Finish module
 
-//   mz_kpp.add_line("#endif");
-     string last_line="END MODULE " + module_name;
-     mz_kpp.add_line("");
-     mz_kpp.add_line(last_line);
-
-// Handle e5 module
-
-//    for(it=e5_subroutines.begin();it!=e5_subroutines.end();it++) {
-//      e5_kpp.add_line(" ");
-//      it->copy_to_MZ_KPP(e5_kpp);
-//    }
-
-//    last_line = last_line + "_e5";
-//    e5_kpp.add_line(" ");
-//    e5_kpp.add_line(last_line);
+   string last_line="end module " + module_name;
+   mz_kpp.add_line("");
+   mz_kpp.add_line(last_line);
 
 // Write the complete module to file: mz_kpp.f
@@ -376,4 +375,21 @@
    string                          diline;
 
+// Read mechanism from mech_list
+
+   in.open("mech_list");
+   if( !in ) {
+      cout << "cannot open " << endl; my_abort("mech_list");
+   }
+
+   while ( 1 ) {
+     getline (in, buf);
+     if( in.eof() ) break;
+     if( in.bad() ) my_abort("ERROR_READ_4");
+     line.set_line(buf);
+     mz_kpp.add_line(line);
+   }
+   in.close();
+
+
 // Read Modul Header from file $MZ_KPP_HOME/templates/module_header
 
@@ -394,40 +410,27 @@
    mz_kpp.add_line("                                                                 "); 
    if(kpp_switches.is_vector()) {
-       mz_kpp.add_line("  LOGICAL,  PARAMETER          :: l_vector = .TRUE.             ");
-   } else {
-       mz_kpp.add_line("  LOGICAL,  PARAMETER          :: l_vector = .FALSE.            ");
+       mz_kpp.add_line("  logical,parameter          :: L_VECTOR = .TRUE.             ");
+   } else {
+       mz_kpp.add_line("  logical,parameter          :: L_VECTOR = .FALSE.            ");
    }
 //  mz_pj_20070531+
    sprintf(distr,"%i",kpp_switches.de_indexing());
    diline = distr ;
-   mz_kpp.add_line("  INTEGER,  PARAMETER          :: i_lu_di = " + diline );
+   mz_kpp.add_line("  integer,parameter          :: I_LU_DI = " + diline );
 //  mz_pj_20070531-
 
-   mz_kpp.add_line("  INTEGER,  PARAMETER          :: vl_dim = " 
-                   + kpp_switches.get_vector_length() ); 
-   mz_kpp.add_line("  INTEGER                     :: vl                              "); 
+   mz_kpp.add_line("  integer,parameter          :: VL_DIM = " 
+                 + kpp_switches.get_vector_length() ); 
+   mz_kpp.add_line("  integer                     :: vl                              "); 
    mz_kpp.add_line("                                                                 "); 
-   mz_kpp.add_line("  INTEGER                     :: vl_glo                          "); 
-   mz_kpp.add_line("  INTEGER                     :: is,ie                           "); 
+   mz_kpp.add_line("  integer                     :: VL_glo                          "); 
+   mz_kpp.add_line("  integer                     :: is,ie                           "); 
    mz_kpp.add_line("                                                                 "); 
-   mz_kpp.add_line("  INTEGER,  DIMENSION(vl_dim)  :: kacc, krej                      "); 
-   mz_kpp.add_line("  INTEGER,  DIMENSION(vl_dim)  :: ierrv                           "); 
-   mz_kpp.add_line("  LOGICAL                     :: data_loaded = .false.             "); 
-   
+   mz_kpp.add_line("                                                                 "); 
+   mz_kpp.add_line("  integer, dimension(VL_dim)   :: Kacc,Krej                       "); 
+   mz_kpp.add_line("  integer, dimension(VL_dim)   :: IERRV                           "); 
+   mz_kpp.add_line("  logical                     :: data_loaded = .false.             "); 
+
    in.close();
-
-//    in_e5.open("module_header_e5");
-//    if( !in_e5 ) {
-//       cout << "cannot open " << endl; my_abort("module_header_e5");
-//    }
-
-//    while ( 1 ) {
-//      getline (in_e5, buf);
-//      if( in_e5.eof() ) break;
-//      if( in_e5.bad() ) my_abort("ERROR_READ_4");
-//      line.set_line(buf);
-//      e5_kpp.add_line(line);
-//    }
-//    in_e5.close();
 
    return;
@@ -448,13 +451,4 @@
    out.close();
    
-//    out_file  = "kk_mecca_kpp_e5.f90";
-//    out_e5.open(out_file.c_str(), ios::out);
-//    if( !out_e5 ) {
-//       cout << "cannot open " << endl; my_abort(out_file);
-//    }
-
-//    e5_kpp.write_file (out_e5);
-
-//    out_e5.close();
 
    return;
@@ -468,48 +462,73 @@
    kppi.set_name("chem_gasphase_integrate");
 
-   kppi.add_line("SUBROUTINE chem_gasphase_integrate (time_step_len, conc, tempk, photo, ierrf, xnacc, xnrej, istatus, l_debug, pe )  ");
+   kppi.add_line("SUBROUTINE chem_gasphase_integrate (time_step_len, conc, tempi, qvapi, fakti, photo, ierrf, xnacc, xnrej, istatus, l_debug, pe, icntrl_i, rcntrl_i )  ");
    kppi.add_line("                                                                    ");
    kppi.add_line("  IMPLICIT NONE                                                     ");
    kppi.add_line("                                                                    ");
 
-   kppi.add_line("  REAL(dp),  INTENT(IN)                    :: time_step_len           ");
+   kppi.add_line("  REAL(dp), INTENT(IN)                   :: time_step_len           ");
    kppi.add_line("  REAL(dp),  DIMENSION(:,:),  INTENT(INOUT) :: conc                    ");
-   kppi.add_line("  REAL(dp),  DIMENSION(:,:),  INTENT(INOUT) :: photo                   ");
-   kppi.add_line("  REAL(dp),  DIMENSION(:),  INTENT(IN)      :: tempk                   ");
-   kppi.add_line("  INTEGER,  INTENT(OUT),  OPTIONAL          :: ierrf(:)                ");
-   kppi.add_line("  INTEGER,  INTENT(OUT),  OPTIONAL          :: xnacc(:)                ");
-   kppi.add_line("  INTEGER,  INTENT(OUT),  OPTIONAL          :: xnrej(:)                ");
-   kppi.add_line("  INTEGER,  INTENT(INOUT),  OPTIONAL        :: istatus(:)              ");
-   kppi.add_line("  INTEGER,  INTENT(IN),  OPTIONAL           :: pe                      ");
-   kppi.add_line("  LOGICAL,  INTENT(IN),  OPTIONAL           :: l_debug                 ");
+   kppi.add_line("  REAL(dp),  DIMENSION(:,:),  INTENT(IN)    :: photo                   ");
+   kppi.add_line("  REAL(dp),  DIMENSION(:),  INTENT(IN)      :: tempi                   ");
+   kppi.add_line("  REAL(dp),  DIMENSION(:),  INTENT(IN)      :: qvapi                   ");
+   kppi.add_line("  REAL(dp),  DIMENSION(:),  INTENT(IN)      :: fakti                   ");
+   kppi.add_line("  INTEGER,  INTENT(OUT), OPTIONAL        :: ierrf(:)                ");
+   kppi.add_line("  INTEGER,  INTENT(OUT), OPTIONAL        :: xNacc(:)                ");
+   kppi.add_line("  INTEGER,  INTENT(OUT), OPTIONAL        :: xNrej(:)                ");
+   kppi.add_line("  INTEGER,  INTENT(INOUT), OPTIONAL      :: istatus(:)              ");
+   kppi.add_line("  INTEGER,  INTENT(IN), OPTIONAL         :: PE                      ");
+   kppi.add_line("  LOGICAL,  INTENT(IN), OPTIONAL         :: l_debug                 ");
+   kppi.add_line("  INTEGER,  DIMENSION(nkppctrl),INTENT(IN), OPTIONAL  :: icntrl_i         ");
+   kppi.add_line("  REAL(dp), DIMENSION(nkppctrl),INTENT(IN), OPTIONAL  :: rcntrl_i         ");
    kppi.add_line("                                                                    ");
    kppi.add_line("  INTEGER                                 :: k   ! loop variable     ");
    kppi.add_line("  REAL(dp)                                :: dt                      ");
-   kppi.add_line("  INTEGER,  DIMENSION(20)                  :: istatus_u               ");
-   kppi.add_line("  INTEGER                                 :: ierr_u                  ");
-   kppi.add_line("                                                                    ");
-   kppi.add_line("                                                                    ");
-   kppi.add_line("  if (present (istatus) )  istatus = 0                              ");
-   kppi.add_line("                                                                    ");
-// kppi.add_line("  vk_glo = size(tempk,1)                                            ");
-// kppi.add_line("                                                                    ");
-
-   kppi.add_line("  DO k=1,vl_glo,vl_dim                                              ");
+   kppi.add_line("  integer, dimension(20)                 :: istatus_u               ");
+   kppi.add_line("  integer                                :: ierr_u                  ");
+   kppi.add_line("  integer                                :: istatf                  ");
+   kppi.add_line("  integer                                :: vl_dim_lo               ");
+   kppi.add_line("                                                                    ");
+   kppi.add_line("                                                                    ");
+   kppi.add_line("  if (present (istatus) )   istatus = 0                             ");
+   kppi.add_line("  if (present (icntrl_i) )  icntrl  = icntrl_i                      ");
+   kppi.add_line("  if (present (rcntrl_i) )  rcntrl  = rcntrl_i                      ");
+   kppi.add_line("                                                                    ");
+   kppi.add_line("  vl_glo = size(tempi,1)                                            ");
+   kppi.add_line("                                                                    ");
+   kppi.add_line("  vl_dim_lo = VL_DIM                                                ");
+   kppi.add_line("  DO k=1,VL_glo,vl_dim_lo                                           ");
    kppi.add_line("    is = k                                                          ");
-   kppi.add_line("    ie = min(k+vl_dim-1,vl_glo)                                     ");
+   kppi.add_line("    ie = min(k+vl_dim_lo-1,VL_glo)                                  ");
    kppi.add_line("    vl = ie-is+1                                                    ");
 
    kppi.add_line("                                                                    ");
    if(kpp_switches.is_vector()) {
-     kppi.add_line("    c(1:vl,:) = conc(is:ie,:)                                     ");
-   } else {
-     kppi.add_line("    c(:) = conc(is,:)                                             ");
-   }
-   kppi.add_line("                                                                    ");
-   if(kpp_switches.is_vector()) {
-     kppi.add_line("    temp(1:vl) = tempk(is:ie)                                     ");
-   } else {
-     kppi.add_line("    temp = tempk(is)                                              ");
-   }
+     kppi.add_line("    C(1:vl,:) = Conc(is:ie,:)                                     ");
+   } else {
+     kppi.add_line("    C(:) = Conc(is,:)                                             ");
+   }
+
+   kppi.add_line("                                                                    ");
+   if(kpp_switches.is_vector()) {
+     kppi.add_line("    temp(1:vl) = tempi(is:ie)                                     ");
+   } else {
+     kppi.add_line("    temp = tempi(is)                                              ");
+   }
+   kppi.add_line("                                                                    ");
+   if(kpp_switches.is_vector()) {
+     kppi.add_line("    qvap(1:vl) = qvapi(is:ie)                                     ");
+   } else {
+     kppi.add_line("    qvap = qvapi(is)                                              ");
+   }
+   kppi.add_line("                                                                    ");
+   if(kpp_switches.is_vector()) {
+     kppi.add_line("    fakt(1:vl) = fakti(is:ie)                                     ");
+   } else {
+     kppi.add_line("    fakt = fakti(is)                                              ");
+   }
+
+   kppi.add_line("                                                                    ");
+   kppi.add_line("    CALL initialize                                                 ");
+
    kppi.add_line("                                                                    ");
    if(kpp_switches.is_vector()) {
@@ -528,10 +547,11 @@
    kppi.add_line("                                                                    ");
    if(kpp_switches.is_vector()) {
-     kppi.add_line("    conc(is:ie,:) = c(1:VL,:)                                     ");
-   } else {
-     kppi.add_line("    IF (PRESENT(l_debug) .AND. PRESENT(pe)) THEN                       ");
-     kppi.add_line("       IF (l_debug) CALL error_output(conc(is,:),ierr_u, pe)           ");
-     kppi.add_line("    ENDIF                                                              ");
-     kppi.add_line("    conc(is,:) = c(:)                                                  ");
+     kppi.add_line("    Conc(is:ie,:) = C(1:VL,:)                                     ");
+   } else {
+     kppi.add_line("   IF (PRESENT(l_debug) .AND. PRESENT(PE)) THEN                       ");
+     kppi.add_line("      IF (l_debug) CALL error_output(Conc(is,:),ierr_u, PE)           ");
+     kppi.add_line("   ENDIF                                                              ");
+     kppi.add_line("                                                                      ");
+     kppi.add_line("    Conc(is,:) = C(:)                                                 ");
    }
 
@@ -540,17 +560,17 @@
    kppi.add_line("                                                                    ");
    if(kpp_switches.is_vector()) {
-     kppi.add_line("    if(PRESENT(ierrf))    ierrf(is:ie) = ierrv(1:vl)              ");
-     kppi.add_line("    if(PRESENT(xnacc))    xnacc(is:ie) = kacc(1:vl)               ");
-     kppi.add_line("    if(PRESENT(xnrej))    xnrej(is:ie) = krej(1:vl)               ");
-   } else {
-     kppi.add_line("    if(PRESENT(ierrf))    ierrf(is) = ierr_u                      ");
-     kppi.add_line("    if(PRESENT(xnacc))    xnacc(is) = istatus_u(4)                ");
-     kppi.add_line("    if(PRESENT(xnrej))    xnrej(is) = istatus_u(5)                ");
-   }
-   kppi.add_line("                                                                    ");
-   kppi.add_line("    if (PRESENT (istatus) )  then                                   ");
-   if(kpp_switches.is_vector()) {
-     kppi.add_line("      istatus(4) =   istatus(4) + sum(kacc(1:vl))                  ");
-     kppi.add_line("      istatus(5) =   istatus(5) + sum(krej(1:vl))                  ");
+     kppi.add_line("    if(Present(ierrf))    ierrf(is:ie) = IERRV(1:VL)              ");
+     kppi.add_line("    if(Present(xNacc))    xNacc(is:ie) = Kacc(1:VL)               ");
+     kppi.add_line("    if(Present(xNrej))    xNrej(is:ie) = Krej(1:VL)               ");
+   } else {
+     kppi.add_line("    if(Present(ierrf))    ierrf(is) = IERR_U                      ");
+     kppi.add_line("    if(Present(xNacc))    xNacc(is) = istatus_u(4)                ");
+     kppi.add_line("    if(Present(xNrej))    xNrej(is) = istatus_u(5)                ");
+   }
+   kppi.add_line("                                                                    ");
+   kppi.add_line("    if (present (istatus) )  then                                   ");
+   if(kpp_switches.is_vector()) {
+     kppi.add_line("      istatus(4) =   istatus(4) + sum(Kacc(1:VL))                  ");
+     kppi.add_line("      istatus(5) =   istatus(5) + sum(Krej(1:VL))                  ");
      kppi.add_line("      istatus(3) =   istatus(4) + istatus(5)                       ");
      kppi.add_line("      istatus(6) =   istatus(6) + istatus_u(6)                     ");
@@ -559,5 +579,5 @@
      kppi.add_line("      istatus(1:8) = istatus(1:8) + istatus_u(1:8)                 ");
    }
-   kppi.add_line("    ENDIF                                                          ");
+   kppi.add_line("    end if                                                          ");
    kppi.add_line("                                                                    ");
    kppi.add_line("  END DO                                                            ");
@@ -568,5 +588,5 @@
    kppi.add_line("                                                                    ");
    for(iv=Vvar_list.begin();iv!=Vvar_list.end();iv++) {
-     kppi.add_line("  if (ALLOCATED("+ iv->name +"))   DEALLOCATE("+ iv->name +" )    ");
+//     kppi.add_line("  if (allocated("+ iv->name +"))   deallocate("+ iv->name +" )    ");
    }
 
@@ -574,5 +594,5 @@
    kppi.add_line("  data_loaded = .false.                                             ");
    kppi.add_line("                                                                    ");
-   kppi.add_line("  RETURN                                                            ");
+   kppi.add_line("  return                                                            ");
    kppi.add_line("END SUBROUTINE chem_gasphase_integrate                                        ");
 
@@ -583,60 +603,2 @@
 }
 
-void create_kpp_module::create_fill_routine(vector<fortran_file> &fi_list, Vvar & var) {
-   fortran_file                         fi;
-   vector<string>::iterator             is;
-   string                               line;
-
-   cout << "Generate fill subroutine for " << var.name << endl;
-
-   fi.set_name(var.name);
-   line = "  SUBROUTINE fill_" + var.name;
-   fi.add_line(line + "(status, array) ");
-     fi.add_line(" ");
-     fi.add_line("    INTEGER,  INTENT(OUT)               :: status ");
-   if(var.nr_dim() == 0) {
-     fi.add_line("    REAL(dp),  INTENT(IN),  DIMENSION(:) :: array ");
-     fi.add_line(" ");
-     fi.add_line("    status = 0");
-     fi.add_line("    IF (.not. ALLOCATED("+var.name+")) & ");
-     fi.add_line("       ALLOCATE("+var.name+"(size(array))) ");
-   } else if(var.nr_dim() == 1) {
-     fi.add_line("    REAL (dp), INTENT(IN), DIMENSION(:,:) :: array ");
-     fi.add_line(" ");
-     fi.add_line("    status = 0 ");
-     fi.add_line("    if (.not. ALLOCATED("+var.name+")) & ");
-     fi.add_line("        ALLOCATE("+var.name+"(size(array,1),"+var.dim_var[0]+")) ");
-   } else if(var.nr_dim() == 2) {
-     fi.add_line(" ");
-     fi.add_line("    REAL (dp), INTENT(IN), DIMENSION(:,:,:) :: array ");
-     fi.add_line(" ");
-     fi.add_line("    status = 0 ");
-     fi.add_line("    if (.not. ALLOCATED("+var.name+")) & ");
-     fi.add_line("        ALLOCATE("+var.name+"(size(array,1),"+var.dim_var[0]+var.dim_var[1]+")) ");
-   } else {
-     fi.add_line("    REAL (dp), INTENT(IN), DIMENSION(:,:,:,:) :: array ");
-     fi.add_line(" ");
-     fi.add_line("    status = 0 ");
-     fi.add_line("    IF (.not. ALLOCATED("+var.name+")) & ");
-     fi.add_line("        ALLOCATE("+var.name+"(size(array,1),"+var.dim_var[0]
-                               +var.dim_var[1]+var.dim_var[3]+")) ");
-   }
-
-   fi.add_line(" ");
-   fi.add_line("    IF (data_loaded .AND. (vl_glo /= size(array,1)) )  THEN ");
-   fi.add_line("       status = 1 ");
-   fi.add_line("       RETURN ");
-   fi.add_line("    END IF ");
-   fi.add_line(" ");
-   fi.add_line("    vl_glo = size(array,1) ");
-   fi.add_line("    "+var.name+ " = array ");
-   fi.add_line("    data_loaded = .TRUE. ");
-   fi.add_line(" ");
-   fi.add_line("    RETURN");
-   fi.add_line(" ");
-   fi.add_line("  END " + line);
-
-   fi_list.push_back(fi);
-
-   return;
-}
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/src/expand_decomp.C
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/src/expand_decomp.C	(revision 3297)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp4palm/src/expand_decomp.C	(revision 3298)
@@ -165,5 +165,5 @@
   vector<fortran_file>::iterator  it;
   fortran_file                    de;
-  int                             k,kk,j,jj,i,ii;
+  int                             k,kk,j,jj,i;
   string                          line;
   char                            cline[80];
